/* Display the settings for the SoundSwitch, if present */

	options results
	parse arg portname helpmode
	
	say "/* V-Station Mix file */"
	say "parse arg vsport;interpret 'address' vsport;vsprivport=vsport'IMP'"
	say 
	call GetSoundSwitch()
	count = result
	call GetTBC()
	count = count + result
	call GetPar()
	count = count + result
	dopar = result
	
	say 
	say "/* The next command instructs the VStation to continue "
	say "   with an edit in progress, if appropriate. */"
	say "interpret 'address' vsprivport 'DONE'"
	
	if dopar > 0 then
		say "if counter > 0 then address DDR stop counter"
	
	say "exit"
	say
	if count > 0 then 
		call MiscFunctions()
	exit
	
CheckSave: procedure expose portname	
	parse arg text
	interpret 'address' portname
	call setclip('mixtext', text)
	ask 'mixtext' 'Yes|No'
	r = result
	call setclip('mixtext')
	if r == 0 then return(0)
	else
	return(1)
end	
	
	
GetSoundSwitch: procedure expose portname
	options results
	if show(Ports, SoundSwitch) ~= 1 then return(0)
	
	if CheckSave("Save SoundSwitch settings?         "||'0a'x||'0a'x||"All mixer levels and gadget settings are stored in the mix for later use.") == 0 then return(0)
	else
	
	say
	say "/* Setup commands for the SunRize SoundSwitch */"
	say "call findaddress(SOUNDSWITCH)"
	say "address SOUNDSWITCH"
	address SOUNDSWITCH
	
	GETAUTOSWITCH;	say "SETAUTOSWITCH" RESULT
	GETAUTOMAP;	say "SETAUTOMAP" RESULT
	GETEFFECT MAIN PREVIEW;	say "SETEFFECT" RESULT
	GETGAIN;	say "SETGAIN" RESULT
	GETTRIM;	say "SETTRIM" RESULT
	GETBUS;	say "SETBUS" RESULT
	
	return(1)

GetTBC: procedure expose portname

	if show(Ports, TBC) ~= 1 then return(0)
	
	if CheckSave("Save TBC settings?               "||'0a'x||'0a'x||"All of the TBC variables accessable through ARexx are stored, giving various mixes the ability to configure the TBCs differently.") == 0 then return(0)
	else
	say
	say "/* Setup commands for the DPS TBC-IV's */"
	say "call findaddress(TBC)"
	say "address TBC"
	address TBC
	
	Do i = 4 to 1 by -1
		TBC i; 		Say 'TBC "'Result'"'
		FMODE;		Say 'fmode "'Result'"'
		MONO;			Say 'mono "'Result'"'
		STROBE;		Say 'strobe "'Result'"'
		FIELD;		Say 'field "'Result'"'
		GPI;			Say 'gpi "'Result'"'
		GPIMOD;		Say 'gpimod "'Result'"'
		VIDEO; 		Say 'video "'Result'"'
		BLACK;		Say 'black "'Result'"'
		CHROMA;		Say 'chroma "'Result'"'
		HUE;			Say 'hue "'Result'"'
		FINE;			Say 'fine "'Result'"'
		COARSE;		Say 'coarse "'Result'"'
		HORIZ;		Say 'horiz "'Result'"'
		BLUE;			Say 'blue "'Result'"'
		RED;			Say 'red "'Result'"'
	End
	
	Do i = 1 to 10
		PROCAMP i ; Say 'PROCAMP' i' "'Result'"'
	End
	
	return(1)
	
GetPar: procedure expose portname
	if show(Ports, DDR) ~= 1 then return(0)
	
	if CheckSave("Save PAR settings?                         "||'0a'x||'0a'x||"This will save the current animation, position, speed, and other settings. If the PAR does not have the GPI or SMPTE button depressed, the PAR will be configured to display the current frame as a still image instead of a GPI/SMPTE triggered animation. If using the GPI to trigger animation playback, make sure the GPI settings in the Edit Options window are set appropriately (Type C) and that the GPI cable is correct for the PAR; it uses a different joystick pin connection than the Toaster's GPI.") == 0 then return(0)
	else
	
	say
	say "/* Setup commands for the DPS PAR */"
	say "call findaddress(DDR)"
	say "drop counter"
	say "address DDR"	
	address DDR
	
	/* Stop it if it is playing now */
	stop
	gpi;	
	gmode = result
	say "gpi off"	
	say "stop"	
	say "pause off"
	/* the basic config information */
	stunt; say "stunt" result
	/* sub; say "sub" result  --- this command is buggy! */
	genlock;	say "genlock" result
	horiz; say "horiz '"result"'"
	mono;	say "mono" result
	
	
	/* if in etoe mode, then there is no animation information */
	etoe;	say "etoe" result
	if result == ON then signal donepar;
	
	/* turn on etoe for a bit to hide garbage.. */
	say "etoe on"
	
	/* animation information */
	project;	say "project" result
	file;	say "file '"result"'"
	
	/* Check for a still image */
	jumpframe;
	frame = result
	if frame == 0 then signal donepar
	
	loop;	say "loop" result
	smpte; say "smpte" result
	smode = result
	
	say "gpi" gmode
	say "stop"
	
	startframe;	say "startframe" result
	endframe; say "counter = " result
	say "endframe counter"
	
	if (gmode == ON) | (smode == ON) then do
		/* do differently if slowmode */
		slow;	say "slow" result
		if result == ON then do
			fps;	say "fps" result
			say "slow on"
			say "pause off"
			say "play"
			say "pause on"
			say "jumpframe" frame
			end
		else do
			say "jumpframe" frame
			say "pause on"
			say "play"
			end
		end		
	else say "jumpframe" frame
	say "etoe off"
	
donepar:	
	return(1)

/* These are functions appended to the end of every mix file */
MiscFunctions: procedure
	say 
	say "findaddress: procedure expose vsport vsprivport"
	say " arg portname"
	say 
	say " if show(Ports, portname) ~= 1 then do"
	say "   interpret 'address' vsprivport 'abort'"
	say "   setclip('asktext', 'Unable to find the ARexx port 'portname'. Please start the correct program and try again, or prepare a different mix for this event.')"
	say "   interpret 'address' vsport '"||'ask '||'"asktext" "Abort Mix"'||"'"
	say "   setclip('asktext')"
	say "   exit"
	say " end"
	say 
	say " return(1)"	
	
return(1)
